﻿using Syncfusion.SfSkinManager;
using Syncfusion.Windows.Shared;
using Syncfusion.Windows.Tools;
using Syncfusion.Windows.Tools.Controls;
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml;

namespace WpfApp1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : RibbonWindow
    {

        public MainWindow()
        {
            
            InitializeComponent();
            SfSkinManager.ApplyStylesOnApplication = true;
            comboBox.SelectedIndex = 0;
        }
        
        private void OnLauncherClick(object sender, RoutedEventArgs e)
        {
            MessageBox.Show("Launcher button clicked");
        }

        private void OnFlowDirection(object sender, RoutedEventArgs e)
        {
           this.FlowDirection = FlowDirection.RightToLeft;
        }

        private void OnDisable(object sender, RoutedEventArgs e)
        {
            simplebtns.IsEnabled = !simplebtns.IsEnabled;
            dropbtns.IsEnabled = !dropbtns.IsEnabled;
        }

        private void OnModal(object sender, RoutedEventArgs e)
        {
            MyRibbon.ShowModalTab("printpreview");
        }    

        private void Return(object sender, RoutedEventArgs e)
        {
            MyRibbon.HideBackStage();
        }

        private void Exit(object sender, RoutedEventArgs e)
        {
            this.Close();
        }
        
        private void CloseModalTab_Click(object sender, RoutedEventArgs e)
        {
            this.MyRibbon.CloseModalTabs();
        }

        private void ComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (comboBox.SelectedIndex == 0)
            {
                SfSkinManager.SetVisualStyle(this, VisualStyles.Metro);
            }
            else if (comboBox.SelectedIndex == 1)
            {
                SfSkinManager.SetVisualStyle(this, VisualStyles.Lime);
            }
            else if (comboBox.SelectedIndex == 2)
            {
                SfSkinManager.SetVisualStyle(this, VisualStyles.Saffron);
            }
            else if (comboBox.SelectedIndex == 3)
            {
                SfSkinManager.SetVisualStyle(this, VisualStyles.Blend);
            }
            else if (comboBox.SelectedIndex == 4)
            {
                SfSkinManager.SetVisualStyle(this, VisualStyles.Office2013White);
            }
            else if (comboBox.SelectedIndex == 5)
            {
                SfSkinManager.SetVisualStyle(this, VisualStyles.Office2013LightGray);
            }
            else if (comboBox.SelectedIndex == 6)
            {
                SfSkinManager.SetVisualStyle(this, VisualStyles.Office2013DarkGray);
            }
            else if (comboBox.SelectedIndex == 7)
            {
                SfSkinManager.SetVisualStyle(this, VisualStyles.VisualStudio2013);
            }
            else if (comboBox.SelectedIndex == 8)
            {
                SfSkinManager.SetVisualStyle(this, VisualStyles.Office2010Black);
            }
            else if (comboBox.SelectedIndex == 9)
            {
                SfSkinManager.SetVisualStyle(this, VisualStyles.Office2010Blue);
            }
            else if (comboBox.SelectedIndex == 10)
            {
                SfSkinManager.SetVisualStyle(this, VisualStyles.Office2010Silver);
            }
            else if (comboBox.SelectedIndex == 11)
            {
                SfSkinManager.SetVisualStyle(this, VisualStyles.Office365);
            }
            else if (comboBox.SelectedIndex == 12)
            {
                SfSkinManager.SetVisualStyle(this, VisualStyles.Office2016Colorful);
            }
            else if (comboBox.SelectedIndex == 13)
            {
                SfSkinManager.SetVisualStyle(this, VisualStyles.Office2016White);
            }
            else if (comboBox.SelectedIndex == 14)
            {
                SfSkinManager.SetVisualStyle(this, VisualStyles.Office2016DarkGray);
            }
            else if (comboBox.SelectedIndex == 15)
            {
                SfSkinManager.SetVisualStyle(this, VisualStyles.VisualStudio2015);
            }

        }

        private void CheckBox_Checked(object sender, RoutedEventArgs e)
        {
            this.FlowDirection = FlowDirection.RightToLeft;
        }

        private void CheckBox_Unchecked(object sender, RoutedEventArgs e)
        {
            this.FlowDirection = FlowDirection.LeftToRight;
        }

        private void CheckBox_Checked_1(object sender, RoutedEventArgs e)
        {
            MyRibbon.ShowBackStage();
            checkBox1.IsChecked = false;
        }

        private void CheckBox_Checked_3(object sender, RoutedEventArgs e)
        {
            //ribbonGallery.VisualMode = Syncfusion.Windows.Tools.RibbonGalleryVisualMode.DropDown;
        }

        private void CheckBox_Unchecked_1(object sender, RoutedEventArgs e)
        {
            //ribbonGallery.VisualMode = RibbonGalleryVisualMode.InRibbon;
        }

        private void CheckBox_Checked_2(object sender, RoutedEventArgs e)
        {
            SetValue(RibbonContextMenu.IsCustomContextMenuItemsOnTopProperty, true);
        }

        private void CheckBox_Unchecked_2(object sender, RoutedEventArgs e)
        {
            SetValue(RibbonContextMenu.IsCustomContextMenuItemsOnTopProperty, false);
        }

        private void RibbonStateComboBox_SelectionChanged_1(object sender, SelectionChangedEventArgs e)
        {
            if (this.RibbonStateComboBox.SelectedIndex == 0)
                this.MyRibbon.RibbonState = Syncfusion.Windows.Tools.RibbonState.Normal;
            else if (this.RibbonStateComboBox.SelectedIndex == 1)
                this.MyRibbon.RibbonState = Syncfusion.Windows.Tools.RibbonState.Hide;
            else
                this.MyRibbon.RibbonState = Syncfusion.Windows.Tools.RibbonState.Adorner;
        }

        private void CheckBox_Checked_4(object sender, RoutedEventArgs e)
        {
            this.tabGroup.IsGroupVisible = true;
        }

        private void CheckBox_Unchecked_3(object sender, RoutedEventArgs e)
        {
            this.tabGroup.IsGroupVisible = false;
        }

        private const string SaveLocation = @"../../Resources/temp1.xml";

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            using (var stream = new FileStream(SaveLocation, FileMode.Create))
            using (var writer = XmlWriter.Create(stream))
            {
                this.MyRibbon.SaveRibbonState(writer);
            }
        }

        private void deserializeButton_Click_1(object sender, RoutedEventArgs e)
        {
            if (!File.Exists(SaveLocation))
            {
                return;
            }
            using (var reader = new StringReader(File.ReadAllText(SaveLocation)))
            {
                this.MyRibbon.LoadRibbonState(reader);
            }
        }

        private void ComboBox_SelectionChanged_1(object sender, SelectionChangedEventArgs e)
        {
            SkinStorage.SetVisualStyle(this, (ThemeComboBox.SelectedValue as System.Windows.Controls.ComboBoxItem).Content.ToString());
        }
    }
}
